# -*- coding: utf-8 -*-

import unittest
import os
import sys
import codecs
import logging
import base64
import zlib

from ksearch.parser.htmlparser import *

class HtmlParserTestCase(unittest.TestCase):
    def test_text(self):
        html_data = open(os.path.join(os.path.dirname(__file__), 
            "test_data/test.html")).read()
        html_parsed_data = open(os.path.join(os.path.dirname(__file__), 
            "test_data/test.txt")).read().decode('utf8')
        hp = HtmlParser()
        result = hp.text(html_data)
        self.assertEquals(hp.text(html_data), html_parsed_data)

    def test_kaist(self):
        html_data = open(os.path.join(os.path.dirname(__file__), 
            "test_data/kaist.html")).read()
        html_parsed_data = open(os.path.join(os.path.dirname(__file__), 
            "test_data/kaist.txt")).read().decode('utf8')
        hp = HtmlParser()
        result = hp.text(html_data)
        self.assertEquals(hp.text(html_data), html_parsed_data)



def suite():
    return unittest.TestLoader().\
        loadTestsFromTestCase(HtmlParserTestCase)

if __name__ == "__main__":
    unittest.TextTestRunner(verbosity=2).run(suite())   #pragma: no cover

