#!/usr/bin/env python
'''
DocIndexer MS Word parser.
Uses Antiword to extract text from Word documents.
'''
import os, string, tempfile
from ksearch import util

class WordParser(object):

    description = 'Antiword document parser'
    mime_types = ['application/antiword']

    def __init__(self):
        self.app_dir = os.path.join(
                            os.path.dirname(__file__),
                            "../../thirdparty/bin")
        self.app_path = os.path.join(
                            self.app_dir,
                            "antiword")
        self.app_res_path = os.path.join(
                            self.app_dir,
                            "Resources")
        self.app_path = "antiword"

    def text(self,str):
        fd, fn = tempfile.mkstemp(".doc")
        f = open(fn, "w+b")
        f.write(str)
        f.close()
        ret = self.text_from_file(f.name)
        os.remove(f.name)
        return ret

    def text_from_file(self,filename):
        cmd = "%s -w 0 '%s'" % (self.app_path, filename.replace("'", r"\'"))
        #os.putenv("ANTIWORDHOME", self.app_res_path)
        try:
            f = os.popen(cmd)
            text = f.read()
            err = f.close()
            if err is not None:
                raise Exception,'non-zero Antiword exit status %d' % err
            if not string.strip(text):
                # KLUDGE: Because batch command exit codes are broken on Win9X.
                raise Exception,'Antiword unable to read document'
            return util.smart_unicode(text)
        except Exception:
            raise
        except:
            raise Exception,'unable to execute Antiword'


if __name__ == '__main__':
    pass

# vim: set ts=4 sw=4:
