#!/usr/bin/env python
#-*- coding: utf-8 -*-

import logging
import os
import optparse
import sys
import Pyro.core
import Pyro.util

sys.path.append(os.path.join(os.path.dirname(__file__), '..'))

from ksearch.search import pagerankcalculator
from ksearch.crawler.storage import Storage
from ksearch.util.graph import get_graph

def sliced(list, size):
    result=[]
    for i in range(0, len(list), size):
        result.append(list[i:i+size])
    return result

if __name__ == '__main__':
    parser = optparse.OptionParser()
    parser.add_option("-n", "--namespace", dest="object_namespace", default="ksearch_main",
                      help="Object name to register in NS")
    parser.add_option("-i", "--iterations", dest="iterations", default=20,
                      help="Number of iterations to calculate PageRank(20 > recommended)")
    parser.add_option("", "--storage_path", dest="storage_path", default="storage_db",
                      help="The storage path")
    options, args = parser.parse_args()

    storage = Pyro.core.getProxyForURI("PYRONAME://:%s.storage"%options.object_namespace)
    #storage._setOneway(['set_pagerank'])
    database = Pyro.core.getProxyForURI("PYRONAME://:%s.database"%options.object_namespace)
    idxqueue = Pyro.core.getProxyForURI("PYRONAME://:%s.idxqueue"%options.object_namespace)
    #idxqueue._setOneway(['append'])
    #storage = Storage(options.storage_path)

    result = pagerankcalculator.PageRankCalculator.get_pagerank(storage, database,
            iterations=int(options.iterations))
   
    docid_rank = list(enumerate(result))
    docid_rank.sort(key=lambda p: p[1], reverse=True)

    print "Updating boost..."
    for slice in sliced(docid_rank, 1000):
        storage.set_pagerank(slice)

        for docid, pagerank in slice:
	    idxqueue.append(str(docid))
