from ksearch.util import extract_links
from ksearch.util.graph import get_graph
import urlparse

class PageRankCalculator(object):

    def calculate(cls, docid_list, inlink_list, outlink_list, iterations=20):
        # Initialize 
        pagerank = [1.0] * (max(docid_list) + 1)

        for iter in range(iterations):
            print "%dth iteration ..." % (iter+1)
            for docid in docid_list:
                pr = 0.15
                for inlink in inlink_list[docid]:
                    pr += 0.85 * (pagerank[inlink] / len(outlink_list[inlink]))
                pagerank[docid] = pr

        return pagerank
            
    calculate = classmethod(calculate)

    def get_pagerank(cls, storage, database, iterations=20):
        docid_max = storage.get_last_id() + 1
        docid_list = []
        inlink_list = [[] for i in range(docid_max)]
        outlink_list = [[] for i in range(docid_max)]

        print "docid_max:", docid_max

        url_map = {}
        graph = get_graph()
        labeled_urls = set()

        for docid in range(docid_max):
            if docid % 100 == 0:
                print docid, "documents..."
            url = storage.get_url(docid)
            if url == None:continue

            url_map[docid] = url
            graph.new_url(url)
            # label the url if it's a first host to be added
            _, host, _, _, _, _ = urlparse.urlparse(url)
            if host not in labeled_urls:
                labeled_urls.add(host)
                graph.label_url(url)

            docid_list.append(docid)
            outlinks = (x[1] for x in database.get_all("outlinks", url))

            for outlink_url in outlinks:
                outlink = storage.get_id(outlink_url)
                if outlink == None: continue
                if outlink >= docid_max: continue

                inlink_list[outlink].append(docid)
                outlink_list[docid].append(outlink)
                graph.new_link(url, outlink_url)
            
        pageranks = cls.calculate(docid_list, inlink_list, outlink_list, iterations)

        return pageranks

    get_pagerank = classmethod(get_pagerank)
