#!/bin/bash

kill_matching () {
  PIDS=`pgrep -f "$1"`
  if [ ! -z "$PIDS" ]; then kill $PIDS; fi
}

echo "Stopping web server..."
kill_matching "python test_server.py"

echo "Stopping downloaders..."
kill_matching "python ./run_downloader.py"

sleep 5

echo "Stopping document indexers..."
kill_matching "python ./run_document_indexer.py"

echo "Stopping searcher service..."
kill_matching "python ./run_searcher_service.py"

sleep 3

echo "Stopping indexer service..."
kill_matching "python ./run_indexer_service.py"

echo "Stopping crawler server..."
kill_matching "python ./run_crawler_server.py"

echo "Stopping Pyro NS..."
kill_matching "python -O -tt -c import Pyro.naming,sys"
