#!/usr/bin/env python

import logging
import optparse
import sys
import os

sys.path.append(os.path.join(os.path.dirname(__file__), '..'))

from ksearch.frontend import frontend

def handle(request):
    return Response(body="Hello, world")

def clean_up(signal, frame):
    logging.info("Cleaning up test web server...")
    sys.exit(0)

import signal
signal.signal(signal.SIGTERM, clean_up)
signal.signal(signal.SIGQUIT, clean_up)

if __name__ == '__main__':
    logger = logging.getLogger("frontend")
    parser = optparse.OptionParser()
    parser.add_option("-p", "--port=", dest="port", default=8000, type="int",
                      help="The port to bind")
    parser.add_option("-n", "--namespace", dest="object_namespace", default="ksearch_main",
                      help="Object name in NS")
    options, args = parser.parse_args()
    logger.info("Args parsed: %s", repr(options.__dict__))

    sf = frontend.get_handler(options.object_namespace)

    logger.info("Serving HTTP on port %d...", options.port)

    #from wsgiref.simple_server import make_server, demo_app
    #httpd = make_server('', options.port, sf)
    #httpd.serve_forever()

    from frontend.wsgiserver import CherryPyWSGIServer
    server = CherryPyWSGIServer(("0.0.0.0", options.port), sf)
    server.start()
